chrome.browserAction.setBadgeText({
  text: badgeText
});

chrome.commands.onCommand.addListener(function(command) {
  var bg = chrome.extension.getBackgroundPage();

  if (command === "open_playlist") {
    chrome.storage.local.get({
      defOnline: true
    }, function(items) {
      if (items.defOnline)
        bg.openOnline();
      else
        bg.openPlaylistHandler();
    });
  }
  if (command === "add_webpage") {
    bg.addArticle();
  }

  if (command === "capti_toolbox") {
    executeShowToolbox(false, true);
  }


  if (command === "capti_play_selected") {
    executeShowToolbox(true, null);
  }
});

function executeShowToolbox(startPlayback, isMaximized) {
  bg.getToolboxState(function(isShowed) {
    if (null != isShowed && undefined != isShowed) {
      bg.getSelectionContent(function(selectionText) {
        if (selectionText) {
          bg.showBaseToolBox({selectedText:selectionText, startPlayback:startPlayback, isMaximized:isMaximized});
        } else {
          getPageEntryContent(function(pageText) {
            bg.showBaseToolBox({selectedText:pageText, startPlayback:startPlayback, isMaximized:isMaximized});
          });
        }
      });
    } else {
      bg.showErrorStateNotification(isShowed);
    }
  });
}
