var bg = chrome.extension.getBackgroundPage();

var playSelectionMenuItem = chrome.contextMenus.create({
  "title": chrome.i18n.getMessage("playSelectionMenuItemTitle"),
  "contexts": ['selection'],
  "onclick": function(info, tab) {
    itemOnClickHandler(info, tab, true);
  }
});

var viewSelectionMenuItem = chrome.contextMenus.create({
  "title": chrome.i18n.getMessage("viewSelectionMenuItemTitle"),
  "contexts": ['page', 'selection'],
  "onclick": function(info, tab) {
    itemOnClickHandler(info, tab, false);
  }
});


var definitionMenuItem = chrome.contextMenus.create({
  "title": chrome.i18n.getMessage("definitionMenuItemTitle"),
  "contexts": ['page', 'selection'],
  "onclick": function(info, tab) {
    bg.showDictionaryDialog(true, null);
  }
});

var translateMenuItem = chrome.contextMenus.create({
  "title": chrome.i18n.getMessage("translateMenuItemTitle"),
  "contexts": ['page', 'selection'],
  "onclick": function(info, tab) {
    bg.showDictionaryDialog(false, null);
  }
});

var urlMenuItem = chrome.contextMenus.create({
  "title": chrome.i18n.getMessage("urlMenuItemTitle"),
  "contexts": ['link'],
  "onclick": function(info, tab) {
    // bg.showDictionaryDialog(false, null);
    showImportLinkDialog(info.linkUrl);
  }
});

var imageMenuItem = chrome.contextMenus.create({
  "title": chrome.i18n.getMessage("imageMenuItemTitle"),
  "contexts": ['image'],
  "onclick": function(info, tab) {
    showImportLinkDialog(info.srcUrl);
  }
});



function itemOnClickHandler(info, tab, isSelectionItem) {
  console.log("info: " + JSON.stringify(info));
  console.log("tab: " + JSON.stringify(tab));
  bg.getToolboxState(function(isShowed) {
    if (null != isShowed && undefined != isShowed) {
      if (isSelectionItem) {
        bg.showToolBox(info.selectionText, true);
      } else {
        if (info && info.selectionText) {
          bg.showToolBox(info.selectionText, false);
        } else {
          bg.getPageEntryContent(function(text) {
            bg.showToolBox(text, false);
          });
        }
      }
    } else {
      bg.showErrorStateNotification(isShowed);
    }
  });
}
