function getWordObj(selection) {
  console.log(selection);
  if (selection) {
    var par_el = document.createElement("div");
    par_el.innerHTML = selection["parentElement"];
    return defineWordObj(selection["nodeValue"],
      selection["startOffset"],
      selection["endOffset"],
      par_el.firstElementChild,
      null);
  } else {
    var sel = window.getSelection();
    if (null != sel && sel.rangeCount > 0) {
      var range = sel.getRangeAt(0);
      return defineWordObj(range.commonAncestorContainer.nodeValue,
        range.startOffset,
        range.endOffset,
        range.commonAncestorContainer.parentElement,
        null);
    }
  }
}

function getTextToTranslate(selection) {
  return selection ? selection["selectionValue"].trim() :
    (window.getSelection() ? window.getSelection().toString().trim() : null);
}

function defineWordObj(text, start_selection, end_selection, parentElement, wordInfo) {
  if (text) {
    var defined_word = null != wordInfo && wordInfo.word ? wordInfo.word : text.slice(start_selection, end_selection);
    var start_word_pos = null != wordInfo ? wordInfo.start_pos : start_selection;
    var end_word_pos = null != wordInfo ? wordInfo.end_pos : end_selection;
    if ("" != defined_word.trim() && 1 == defined_word.trim().split(" ").length) {
      var text_part_left = text.slice(0, start_selection);
      var text_reversed = text_part_left.split('').reverse().join("");
      var start_index = text_reversed.search(/\s[\.\!\?]/g);

      var text_right_part = text.slice(end_selection, text.length);
      var end_index = text_right_part.search(/[\.\!\?]\s/g);

      if (parentElement && (-1 == start_index || -1 == end_index)) {
        var parentText = parentElement.innerText;
        if (parentText.length != text.length) {
          if (-1 != start_index) {
            text = text.slice(start_selection - start_index, text.length);
            start_word_pos = start_index;
          }

          let endPos = null;
          if (-1 != end_index) {
            endPos = end_selection + end_index;
          }

          let searchText = text.slice(0, null != endPos ? endPos : 50);
          let start_con_pos = parentText.indexOf(searchText);
          if (-1 != start_con_pos) {
            var end_con_pos = start_con_pos + searchText.length;
            var finded_start_word_pos = start_con_pos + start_word_pos;
            var finded_end_word_pos = finded_start_word_pos + defined_word.length;
            return defineWordObj(parentText, start_con_pos, end_con_pos, null, {
              word: defined_word,
              start_pos: finded_start_word_pos,
              end_pos: finded_end_word_pos
            });
          }
        }
      }

      if (-1 == start_index) {
        start_index = start_selection;
      }

      if (-1 == end_index) {
        end_index = text_right_part.length;
      }

      var start_pos = start_selection - start_index;
      var end_pos = end_selection + end_index + 1;

      let calc_start_word_pos = start_word_pos - start_pos;
      let txt_before = text.slice(start_pos, end_pos);
      let txt_after = txt_before.trim().replace(/\s+/g, " ");
      let wordObj = defined_word.trim();

      calc_start_word_pos -= (txt_before.length - txt_after.length);

      let len_w = defined_word.length - wordObj.length;
      if (0 != len_w && 0 != calc_start_word_pos) {
        calc_start_word_pos += (len_w % 2 ? len_w : len_w - 1);
      }

      if (0 > calc_start_word_pos) {
        calc_start_word_pos = 0;
      }

      return {
        wordInfo: {
          word: wordObj,
          start_pos: calc_start_word_pos,
          end_pos: calc_start_word_pos + defined_word.length
        },
        sentence: txt_after
      };
    } else {
      return null;
    }
  } else {
    return null;
  }
}

chrome.storage.local.get(['selection', 'isDefinition'],
  function(results) {
    var df = getWordObj(results.selection);
    var ts = getTextToTranslate(results.selection);
    obj = {
      definObj: df,
      translateText: ts,
      isDefinition: results.isDefinition
    };
    console.log(obj);
    chrome.runtime.sendMessage({
      dictionary_extractor: 'dic',
      dictionary_obj: obj
    });
  });
