if (window === top && window.location.href.startsWith('https://docs.google.com') &&
  (document.body.getAttribute('itemtype').endsWith('PresentationObject') ||
    document.body.getAttribute('itemtype').endsWith('DocumentObject'))) {
  document.addEventListener("readystatechange", function() {
    var timerId = setInterval(function() {
      var googleMenus = document.querySelectorAll("div[class^='goog-menu goog-menu-vertical docs-material'][tabindex]");
      if (null != googleMenus && 0 != googleMenus.length) {
        googleMenus[0].appendChild(makeCaptiMenuItem('View selection with Capti', 'Alt+X'));
        clearInterval(timerId);
      }
    }, 100);

    setTimeout(function() {
      clearInterval(timerId);
    }, 30000);

  });
} else {
  if (window != top && window.name === 'sdx_ow_iframe') {
    document.addEventListener("DOMNodeInserted", function(event) {
      if (event.target.id === 'mnuSpellingError') {
        makeCaptiMSMenuItem(event.target);
      }
    }, false);
  }
}


function makeCaptiMenuItem(title, shortcut) {
  var item_container = document.createElement('div');
  item_container.id = 'gp:capti_menu_item';
  item_container.className = 'goog-menuitem apps-menuitem';
  item_container.setAttribute('role', 'menuitem');
  item_container.setAttribute('style', 'user-select: none;');

  var icon_container = document.createElement('div');
  icon_container.className = 'docs-icon goog-inline-block goog-menuitem-icon';
  icon_container.setAttribute('aria-hidden', 'false');
  item_container.appendChild(icon_container);

  var icon = document.createElement('div');
  icon.className = 'capti-g-item';
  icon.setAttribute('style', 'background: url(' + chrome.extension.getURL("assets/capti-18.png") + ');');
  icon_container.appendChild(icon);

  var menu_title = document.createElement('span');
  menu_title.className = 'goog-menuitem-label';
  menu_title.innerText = title;
  item_container.onclick = function(ev) {
    console.log('click on capti item');
    chrome.runtime.sendMessage({
      message: '*google-menu-item-action*'
    });
    document.body.firstElementChild.focus();
  };
  item_container.appendChild(menu_title);


  var menu_sortcut = document.createElement('span');
  menu_sortcut.className = 'goog-menuitem-accel';
  menu_sortcut.innerText = shortcut;
  menu_sortcut.setAttribute('aria-label', shortcut);
  item_container.appendChild(menu_sortcut);
  return item_container;
}

function makeCaptiMSMenuItem(container_el) {
  if (null == document.getElementById('msCaptiItem')) {
    var ms_item_text = '<div unselectable="on" class="" id="msCaptiItem"><span unselectable="on" class="cui-menusection-separator" role="separator"></span>' +
      '<div unselectable="on" class="cui-menusection">' +
      '<ul unselectable="on" class="cui-menusection-items">' +
      '<li unselectable="on" class="cui-menusection-items cui-menusection-firstitem" role="presentation">' +
      '<a unselectable="on" tabindex="0" class="cui-ctl-menu cui-ctl-menu16 " mscui:controltype="Button" role="menuitem" id="fseaCaptiItemMenu16" aria-disabled="false" aria-posinset="4" aria-setsize="7">' +
      '<span unselectable="on" class="cui-ctl-iconContainer">' +
      '<span unselectable="on" class=" cui-img-cont-float cui-img-16by16">' +
      '<img unselectable="on" alt="capti-voice" src=\"' + chrome.extension.getURL("assets/capti-16.png") + '\" role="presentation" class="per_CaptiItemDialog_16x16x32">' +
      '</span>' +
      '</span>' +
      '<span unselectable="on" class="cui-ctl-mediumlabel">View selection with Capti</span>' +
      '</a>' +
      '</li>' +
      '</ul>' +
      '</div>' +
      '</div>';

    var menu_container = container_el.firstElementChild;
    var menu_item = document.createElement('div');
    menu_item.innerHTML = ms_item_text;
    menu_container.appendChild(menu_item.firstElementChild);

    var captiItem = document.getElementById('msCaptiItem');
    captiItem.onclick = function(ev) {
      chrome.runtime.sendMessage({
        message: '*ms-menu-item-action*'
      });
      container_el.remove();
    }
  }
}
