// var tempNode = null;
var current_node = null;


//https://en.wikipedia.org/wiki/Portal:History


function preparateContent(textHolder) {
    if ( window.getSelection().toString() ) {
        var selection = window.getSelection();
        var range = selection.getRangeAt(0);
        var commonContainer = range.commonAncestorContainer;
        console.log(commonContainer);
        wrapToSpan(commonContainer, textHolder);
        return true;
    } else {
        console.log("selection is empty!");
        return false;
    }
}

function wrapToSpan(nodeItem, textHolder) {
    if ( nodeItem.nodeType == Node.TEXT_NODE) {
        if (0 !== nodeItem.data.trim().length ) {
            var spanConteinerElement = document.createElement('captispan');
            spanConteinerElement.id = 'capti-span-element';
            var nodeValue = nodeItem.nodeValue;
            textHolder.push(nodeValue);

            var rangeNodeContainer = document.createRange();
            rangeNodeContainer.selectNode(nodeItem);
            rangeNodeContainer.surroundContents(spanConteinerElement);
        }
    } else if ( nodeItem.nodeType == Node.ELEMENT_NODE ) {
        if ( nodeItem.childNodes ) {
            nodeItem.childNodes.forEach(function(item) {
                wrapToSpan(item, textHolder);
            });
        }
    }
}

function removeSpans(){
    var captiSpans = document.querySelectorAll('#capti-span-element');
    console.log(captiSpans.length);
    captiSpans.forEach(function (item) {
        var range = document.createRange();
        range.selectNode(item.firstChild)
        var extractedNode = range.extractContents();
        item.parentNode.insertBefore(extractedNode, item);
        item.remove();
    });
}

function replaceHighlightedWord() {
    var hde = document.getElementById('capti-highligth')
    if (hde) {
        var new_node = null;
        if (!hde.previousSibling) {
            new_node = document.createTextNode(hde.textContent);
        } else {
            new_node = hde.previousSibling;
            new_node.appendData(" ");
            new_node.appendData(hde.textContent.trim());
        }
        hde.parentNode.insertBefore(new_node, hde);
        hde.remove();
    }
}

function highlightWord(word, in_node) {
    console.log("word=", word)
    var highlightEl = document.createElement('captispan');
    highlightEl.id = 'capti-highligth';
    highlightEl.setAttribute('style', 'background: #02f76966;');
    word = word.trim();

    if (null != in_node.data && word.includes(in_node.data) && in_node.data.length < word.length )
    {
        console.log('word slice!');
        word = word.slice(0, in_node.data.length);
    }
    var start_index = in_node.data.indexOf(word);
    var end_index = start_index + word.length;

    console.log(start_index + '-' + end_index);
    console.log(in_node.nodeValue);


    var range = document.createRange();
    range.selectNode(in_node);
    range.setStart(in_node, start_index);
    range.setEnd(in_node, end_index);
    range.surroundContents(highlightEl);
    in_node.remove();
    if ( start_index != 0 ) {
        highlightEl.firstChild.insertData(0, " ");
    }
    if ( highlightEl.nextSibling.textContent.trim().length !== 0 ) {
        return highlightEl.nextSibling;
    } else {
        return null;
    }
}


function simulateSpeech() {
//	var text = "Ancient influences have helped spawn variant interpretations of the nature of history which have evolved over the centuries and continue to change today. The modern study of history is wide-ranging, and includes the study of specific regions and the study of certain topical or thematical elements of historical investigation. Often history is taught as part of primary and secondary education, and the academic study of history is a major discipline in university studies";
    var textHolder = [];
    if ( !preparateContent(textHolder) ) {
        return;
    }

//	var text = textHolder.join(" ");
    var text = "History (from Greek ἱστορία , historia, meaning 'inquiry; knowledge acquired by investigation') is the past as it is described in written documents,";
    console.log(text);
    var words = text.split(" ");
    var index = 0;

    var currentNode = null;
    var captiSpans = Array.from(document.querySelectorAll('#capti-span-element'));
    captiSpans.reverse();

    var loop = setInterval(function() {
        if (index > words.length - 1) {
            clearInterval(loop);
            replaceHighlightedWord();
            removeSpans();
            return;
        }

        console.log(words[index]);

        if( null == currentNode ) {
            var captiSpan = captiSpans.pop();
            currentNode = captiSpan.firstChild;
        }

        replaceHighlightedWord();
        currentNode = highlightWord(words[index], currentNode);

        console.log(currentNode);
        index++;

    }, 300);
}

//preparateContent();
simulateSpeech();
//removeSpans();




/*
var currentNode = null;
function replaceHighlightedWord(skipSpace) {
    var hde = document.getElementById('capti-highligth')
    if (hde) {
        var new_node = null;
        if (!hde.previousSibling) {
            new_node = document.createTextNode(hde.textContent + ' ');
        } else {
            new_node = hde.previousSibling;
            new_node.data += hde.textContent + (!skipSpace ? ' ' : '');
        }
        hde.parentNode.insertBefore(new_node, hde);
        if (skipSpace) {
            hde.nextSibling.remove();
        }
        hde.remove();
    }
}

function highlightWord(word, in_node) {
  var highlightEl = document.createElement('captispan');
  highlightEl.id = 'capti-highligth';
  highlightEl.setAttribute('style', 'background: #02f76966;');
  console.log(word);
  var start_index = in_node.data.indexOf(word);
  var end_index = start_index + word.length;
  console.log(start_index + '-' + end_index);
  console.log(in_node.nodeValue);

  var range = document.createRange();
  range.selectNode(in_node);
  range.setStart(in_node, start_index);
  range.setEnd(in_node, end_index);
  range.surroundContents(highlightEl);
  in_node.remove();
  if ( highlightEl.nextSibling.length !== 0 ) {
    return highlightEl.nextSibling;
  } else {
    return null;
  }
}


function setStartHilglightElement() {
    var captiStartHEl = document.querySelectorAll('[data-capti-start-h-el]')[0];
    console.log(captiStartHEl);
    var arr_p = Array.from(captiStartHEl.childNodes);
    C = arr_p.pop();
    captiStartHEl.removeAttribute('data-capti-start-h-el');
    console.log(current_node);
}

function highlightNode(word) {
    console.log(current_node);
    if (current_node) {
        replaceHighlightedWord(false);
        current_node = highlightWord(word, current_node);
        setTimeout(function () {
            if (null == current_node) {
                replaceHighlightedWord(true);
            }
        }, 600);
    } else {
        console.log("node is null");
    }
}
*/


// function createHighlightElemnent(in_element) {
//   return new Promise((resolve, reject) => {
//     nodeIterate(makeNodeArray(in_element), resolve);
//     tempNode = in_element;
//   });
// }
//
// function makeNodeArray(in_element) {
//   var in_nodes = in_element.childNodes;
//   console.log(in_nodes);
//   var node_arr = Array.from(in_nodes);
//   node_arr = node_arr.reverse();
//   return node_arr;
// }
//
// function nodeIterate(arr_n, resolve) {
//   var in_node = arr_n.pop();
//   if (undefined == in_node) {
//     replaceHighlightedWord(true);
//     resolve(tempNode);
//     return;
//   }
//   console.log(in_node);
//   if (in_node.nodeType && in_node.nodeType === Node.TEXT_NODE) {
//     //console.log(range);
//     var words = in_node.data.split(" ");
//     var line = in_node.nodeValue;
//     console.log(words.length);
//     var index = 0;
//     var loop = setInterval(function() {
//       if (index > words.length - 1) {
//         clearInterval(loop);
//         if (0 != arr_n.lenght) {
//           //							replaceHighlightedWord(true);
//           nodeIterate(arr_n, resolve);
//           return;
//         }
//       }
//
//       replaceHighlightedWord(false);
//       in_node = highlightWord(words[index], in_node);
//       index++;
//
//     }, 150);
//   } else if (in_node.nodeType && in_node.nodeType == Node.ELEMENT_NODE) {
//     nodeIterate(makeNodeArray(in_node), resolve);
//   }
// }

function replaceHighlightedWord(skipSpace) {
    var hde = document.getElementById('capti-highligth')
    if (hde) {
        var new_node = null;
        if (!hde.previousSibling) {
            new_node = document.createTextNode(hde.textContent + ' ');
        } else {
            new_node = hde.previousSibling;
            new_node.data += hde.textContent + (!skipSpace ? ' ' : '');
        }
        hde.parentNode.insertBefore(new_node, hde);
        if (skipSpace) {
            hde.nextSibling.remove();
        }
        hde.remove();
    }
}

function highlightWord(word, in_node) {
    var highlightEl = document.createElement('captispan');
    highlightEl.id = 'capti-highligth';
    highlightEl.setAttribute('style', 'background: #02f76966;');
    console.log(word);
    var start_index = in_node.data.indexOf(word);
    var end_index = start_index + word.length;
    console.log(start_index + '-' + end_index);
    console.log(in_node.nodeValue);

    var range = document.createRange();
    range.selectNode(in_node);
    range.setStart(in_node, start_index);
    range.setEnd(in_node, end_index);
    range.surroundContents(highlightEl);
    in_node.remove();
    if (highlightEl.nextSibling.length !== 0) {
        return highlightEl.nextSibling;
    } else {
        return null;
    }
}

// function run() {
//   var paragraphs = document.querySelectorAll('[data-capti-start-el]');
//   var arr_p = Array.from(paragraphs);
//   arr_p = arr_p.reverse();
//   startHighligth(arr_p);
// }

// function startHighligth(arr_p) {
//   createHighlightElemnent(arr_p.pop()).then(result => {
//     console.log(result);
//     if (0 != arr_p.length) {
//       startHighligth(arr_p);
//     } else {
//       var r_ele = result.nextSibling;
//       if (r_ele) {
//         var a_p = Array.from([r_ele]);
//         a_p = a_p.reverse();
//         startHighligth(a_p);
//       }
//     }
//
//   }, error => {});
// }

bindEvent(window, 'message', function (event) {
    if (event.data.startsWith && event.data.startsWith('*capti-msg-out-word*:')) {
        console.log(event.data);
        var word = event.data.slice(event.data.indexOf(':') + 1, event.data.length);
        highlightNode(word);
    }
});


function bindEvent(element, eventName, eventHandler) {
    if (element.addEventListener) {
        element.addEventListener(eventName, eventHandler, true);
    } else if (element.attachEvent) {
        element.attachEvent('on' + eventName, eventHandler);
    }
}


function setStartHilglightElement() {
    var captiStartHEl = document.querySelectorAll('[data-capti-start-h-el]')[0];
    console.log(captiStartHEl);
    var arr_p = Array.from(captiStartHEl.childNodes);
    current_node = arr_p.pop();
    captiStartHEl.removeAttribute('data-capti-start-h-el');
    console.log(current_node);
}

function highlightNode(word) {
    console.log(current_node);
    if (current_node) {
        replaceHighlightedWord(false);
        current_node = highlightWord(word, current_node);
        setTimeout(function () {
            if (null == current_node) {
                replaceHighlightedWord(true);
            }
        }, 600);
    } else {
        console.log("node is null");
    }
}
