var bg = chrome.extension.getBackgroundPage();
var jSessionId = null;
var vid = chrome.windows.WINDOW_ID_NONE;

function checkLogin(callback) {
    sendRequestWorkspacePage(function(isLogged) {
        if (!isLogged) {
            chrome.windows.get(vid, function(chromeWindow) {
                if (!chrome.runtime.lastError && chromeWindow) {
                    chrome.windows.update(vid, {focused: true});
                    return;
                }
                chrome.windows.create({
                        url: bg.hostUrl + "/roller-ui/signon.rol",
                        focused: true,
                        type: "popup"
                    },
                    function (win) {
                        vid = win.id;
                        chrome.tabs.query({
                            active: true,
                            currentWindow: true
                        }, function (tabs) {
                            var activeTab = tabs[0];
                            var activeTabId = activeTab.id;

                            console.log(callback.toString());

                            function updateFnc(tabId, info, tab) {
                                if (info.url) {
                                    if (info.url.includes("workspace.rol")) {

                                        chrome.windows.remove(win.id);

                                        vid = chrome.windows.WINDOW_ID_NONE;

                                        callback();

                                        if (chrome.tabs.onUpdated.hasListener(updateFnc)) {
                                            chrome.tabs.onUpdated.removeListener(updateFnc);
                                        }
                                    }
                                }
                            }

                            if (!chrome.tabs.onUpdated.hasListener(updateFnc)) {
                                chrome.tabs.onUpdated.addListener(updateFnc);
                            }

                            var removeWindowFunc = function (rwin) {
                                callback = null;
                            };

                            if (!chrome.windows.onRemoved.hasListener(removeWindowFunc)) {
                                chrome.windows.onRemoved.addListener(removeWindowFunc);
                            }
                        });

                    });
            });
        } else {
            callback();
        }
    });
}

function sendRequestWorkspacePage(callback) {
    var xhr = new XMLHttpRequest(); // Creates a new XHR request
    xhr.open("GET", bg.hostUrl + "/roller-ui/workspace.rol", true); // Open the connection
    xhr.setRequestHeader("Content-type", "text/html; charset=utf-8;");
    xhr.withCredentials = "true"; // This sends cookies through
    xhr.onreadystatechange = function() {
        if (xhr.readyState === 4) { // If the response has finished downloading
            if (xhr.status === 200) { // And the content was found
                callback(xhr.responseURL.endsWith("workspace.rol"));
            } else {
                callback(null);
            }
        }
    }

    xhr.send();
}

function getJSessionId(callback) {
    chrome.cookies.get({
        url: bg.hostUrl + "/",
        name: bg.sessionIdKey
    }, function(cookie) {
        callback(null != cookie ? cookie.value : null);
    });
}


function logout(callback) {
    if (window.confirm(chrome.i18n.getMessage("logoutConfirmMessage"))) {
        chrome.cookies.remove({
            url: bg.hostUrl + "/",
            name: bg.sessionIdKey
        }, function() {
            callback();
        });
    }
}

function showLoginNotification() {
    chrome.notifications.create({
        type: "basic",
        title: bg.appName,
        iconUrl: "assets/capti-36.png",
        message: chrome.i18n.getMessage("loginNotificationMessage")
    });
}
