function openOnline() {
  chrome.storage.local.set({
    defOnline: true
  }, function(items) {});


  getAllOurOnlineTabs(function(ourTabs) {
    if (ourTabs.length === 0) {
      // no tabs found - create a new tab
      chrome.tabs.create({
        url: onlineURL
      });
    } else {
      // switch to one of the pre-existing tabs and close all the rest
      // except for pinned tabs
      // give priority to (1) the current tab (2) pinned tab (3) any tab
      var bestTab = null;
      for (var i = 0; i < ourTabs.length; i++) {
        if (ourTabs[i].active) {
          bestTab = ourTabs[i];
          break;
        }
        if (!bestTab || ourTabs[i].pinned)
          bestTab = ourTabs[i];
      }
      for (var i = 0; i < ourTabs.length; i++)
        if (ourTabs[i] !== bestTab)
          chrome.tabs.remove(ourTabs[i].id);
      chrome.tabs.update(bestTab.id, {
        active: true
      });
    }
  });
}

function getAllOurOnlineTabs(callback) {
  chrome.tabs.query({
    currentWindow: true
  }, function(array_of_tabs) {
    var tabs = [];
    for (var i = 0; i < array_of_tabs.length; i++) {
      if (array_of_tabs[i].url === onlineURL)
        tabs.push(array_of_tabs[i]);
    }
    callback(tabs);
  });
}
