document.addEventListener("DOMContentLoaded", function() {
  var on_input = document.getElementById('turn-on-context-menu');
  var off_input = document.getElementById('turn-off-context-menu');
  var options = null;

  chrome.runtime.sendMessage({
    'option_method': 'GET'
  }, function(results) {
    console.log(results);
    options = results;
    (results.captiAllowMenu === 'true') ? checkOption(on_input): checkOption(off_input);
  });

  on_input.onchange = onchangeAllowMenu(true);
  off_input.onchange = onchangeAllowMenu(false);

  function onchangeAllowMenu(flag) {
    return function() {
      options.captiAllowMenu = flag;
    }
  }

  function checkOption(input) {
    input.checked = true;
  }

  var saveBtn = document.getElementById('save-btn');
  saveBtn.onclick = function(ev) {
    chrome.runtime.sendMessage({
      'option_method': 'SET',
      'option_body': options
    });
    window.close();
  }
});
