function checkHost(host) {
  var request;
  if (window.XMLHttpRequest)
    request = new XMLHttpRequest();
  else
    request = new ActiveXObject("Microsoft.XMLHTTP");
  request.open('GET', host, false);
  try {
    request.send();
  } catch (err) {
    return false;
  }
  return request.status === 200;
}

function openPlaylistHandler() {
  chrome.storage.local.set({
    defOnline: false
  }, function(items) {});

  getAllOurTabs(function(ourTabs) {
    if (ourTabs.length === 0) {
      // no tabs found - create a new tab
      if (checkHost(playListURL))
        chrome.tabs.create({
          url: playListURL
        });
      else
        chrome.tabs.create({
          url: getCaptiURL
        });
    } else {
      // switch to one of the pre-existing tabs and close all the rest
      // except for pinned tabs
      // give priority to (1) the current tab (2) pinned tab (3) any tab
      var bestTab = null;
      for (var i = 0; i < ourTabs.length; i++) {
        if (ourTabs[i].active) {
          bestTab = ourTabs[i];
          break;
        }
        if (!bestTab || ourTabs[i].pinned)
          bestTab = ourTabs[i];
      }
      for (var i = 0; i < ourTabs.length; i++)
        if (ourTabs[i] !== bestTab)
          chrome.tabs.remove(ourTabs[i].id);
      chrome.tabs.update(bestTab.id, {
        active: true
      });
    }
  });
}

function getAllOurTabs(callback) {
  function isOurURL(url) {
    if (url.file === "help.html") // ignore help screen, see CJ-902
      return false;
    return url.host === playListHost || (url.host === "localhost" && url.port === '8078');
  }

  chrome.tabs.query({
    currentWindow: true
  }, function(array_of_tabs) {
    var tabs = [];
    for (var i = 0; i < array_of_tabs.length; i++) {
      var url = parseURL(array_of_tabs[i].url);
      if (isOurURL(url))
        tabs.push(array_of_tabs[i]);
    }
    callback(tabs);
  });
}

function parseURL(url) {
  var a = document.createElement('a');
  a.href = url;
  return {
    source: url,
    protocol: a.protocol.replace(':', ''),
    host: a.hostname,
    port: a.port,
    query: a.search,
    params: (function() {
      var ret = {},
        seg = a.search.replace(/^\?/, '').split('&'),
        len = seg.length,
        i = 0,
        s;
      for (; i < len; i++) {
        if (!seg[i]) {
          continue;
        }
        s = seg[i].split('=');
        ret[s[0]] = s[1];
      }
      return ret;
    })(),
    file: (a.pathname.match(/\/([^\/?#]+)$/i) || [, ''])[1],
    hash: a.hash.replace('#', ''),
    path: a.pathname.replace(/^([^\/])/, '/$1'),
    relative: (a.href.match(/tps?:\/\/[^\/]+(.+)/) || [, ''])[1],
    segments: a.pathname.replace(/^\//, '').split('/')
  };
}
