document.addEventListener('DOMContentLoaded', function() {
  chrome.storage.local.get({
    defOnline: true
  }, function(items) {
    var defOnline = items.defOnline;
    var bg = chrome.extension.getBackgroundPage();

    chrome.commands.getAll(function(items) {
      var ch;
/*
      var desktopAvailable = navigator.appVersion.indexOf("Win") != -1 ||
        navigator.appVersion.indexOf("Mac") != -1;
*/
      var skOpenPlaylist = skAddPage = skCaptiToolbox = "";
      for (var i = 0; i < items.length; i++) {
        var item = items[i];
        if (item.name === "open_playlist" && item.shortcut !== "") {
          skOpenPlaylist = "<span class='keys'>" + item.shortcut + "</span>";
        }

        if (item.name === "add_webpage" && item.shortcut !== "") {
          skAddPage = "<span class='keys'>" + item.shortcut + "</span>";

        }
        if (item.name === "capti_toolbox" && item.shortcut !== "") {
          skCaptiToolbox = "<span class='keys'>" + item.shortcut + "</span>";
        }
      }

      if (defOnline) {
        document.getElementById("open_big").innerHTML =
          '<button id="open_playlist" class="bigbutton" tabindex="1">' +
          '    <img class="inbutton" src="assets/capti-open.svg" width="40" />' +
          '    <span>' + chrome.i18n.getMessage("OpenPlaylist") + skOpenPlaylist + '</span>' +
          '</button>';
      } else {
        document.getElementById("open_small").innerHTML =
          '<button id="open_playlist" class="bigbutton" tabindex="3">' +
          '    <img class="inbutton" src="assets/capti-open.svg" width="40" />' +
          '    <span>' + chrome.i18n.getMessage("OpenPlaylist") + '</span>' +
          '</button>';
      }

      document.getElementById("txtAddArticle").innerHTML = chrome.i18n.getMessage("AddArticle") + skAddPage;

      show_help.setAttribute('title', chrome.i18n.getMessage("Help"));
      show_options.setAttribute('title', 'Options');

      var toolboxContainer = document.getElementById("show_toolbox_container");
      toolboxContainer.innerHTML =
        '<button id="open_toolbox" class="bigbutton" tabindex="1">' +
        '    <img class="inbutton" src="assets/capti-show-player.svg" width="40" />' +
        '    <span>' + chrome.i18n.getMessage("showToolboxTitle") +
        skCaptiToolbox + '</span></button>';
      var open_toolbox_btn = document.getElementById("open_toolbox");
      bg.getToolboxState(function(isShowed) {
        open_toolbox_btn.addEventListener('click', function() {
          if (null != isShowed && undefined != isShowed) {
            if (!isShowed) {
              bg.showToolBox(null, false);
            }
            window.close();
          } else {
            bg.showErrorStateNotification(isShowed);
            window.close();
          }
        });
      });

      bg.sendRequestWorkspacePage(function(isLogged) {
        var logged_img = document.getElementById("logged_img");
        logged_btn.setAttribute('title', chrome.i18n.getMessage(isLogged ? "logOutTitle" : "logInTitle"));
        logged_img.setAttribute('src', (isLogged ? "assets/logout.svg" : "assets/login.svg"));
        logged_btn.addEventListener('click', function() {
          if (!isLogged) {
            bg.checkLogin(function() {
              bg.showLoginNotification();
            });

          } else {
            bg.logout(function() {
              window.location.href = "popup.html";
              bg.getToolboxState(function(isShowed) {
                if (null != isShowed && undefined != isShowed && isShowed) {
                  bg.hideToolBox();
                }
              });
            });
          }
        });
      });

      open_playlist.addEventListener('click', function() {
        bg.openOnline();
        window.close();
      });

      if (document.getElementById("open_playlist2") !== null)
        open_playlist2.addEventListener('click', function() {
          bg.openPlaylistHandler();
          window.close();
        });

      add_webpage.addEventListener('click', function() {
        bg.addArticle();
        window.close();
      });

      show_options.addEventListener('click', function() {
        if (chrome.runtime.openOptionsPage) {
          chrome.runtime.openOptionsPage();
        } else {
          window.open(chrome.runtime.getURL('options.html'));
        }
      });

      show_help.addEventListener('click', function() {
        chrome.tabs.create({
          url: bg.helpURL
        });
        window.close();
      });

    });
  });
});
